package cn.com.qmth.stmms.ms.commons.utils;

import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * @Description: 随机数生成工具类
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2019/10/24
 */
public class RandomUtil {
    private static final org.slf4j.Logger LOGGER = LoggerFactory.getLogger(RandomUtil.class);
    public static final int minSize = 1000000;
    public static final int maxSize = 1000001;
    public static final int randomSize = 2000000;
    //    public static Map<Long, List<Long>> randomMap = new HashMap<>();//用map感觉很占内存
    public static List<Long> randomList = new ArrayList<>();//改用list

    /**
     * 根据workId随机生成百万随机数
     *
     * @param workId
     * @param againRandom
     */
    public static void getRandom(Long workId, boolean againRandom) {
        if (randomList.size() > 0) {
            randomList.clear();
        }
        long start = System.currentTimeMillis();
        Long randomSeq = workId % 10;
        randomSeq = randomSeq == 0L ? 1L : randomSeq;
        LOGGER.info("workId:{},开始生成随机数:{}", workId, start);
        Long finalRandomSeq = randomSeq;
        new Thread(() -> {
            Set<Long> set = new HashSet<>();
            for (int i = 0; i < randomSize; i++) {
                long id = (long) (Math.random() * minSize + maxSize * finalRandomSeq);
                set.add(id);
            }
            randomList.addAll(set);
            set.clear();
            long end = System.currentTimeMillis();
            LOGGER.info("workId:{},生成随机数耗时：{},数据长度为:{}", workId, (end - start) / 1000 + "s", randomList.size());
        }).start();
    }
}
